### lcm

Returns the least common multiple of two or more numbers/arrays.

Use the greatest common divisor (GCD) formula and `Math.abs()` to determine the least common multiple.
The GCD formula uses recursion.

```js
const lcm = (...arr) => {
  const gcd = (x, y) => (!y ? x : gcd(y, x % y));
  const _lcm = (x, y) => x * y / gcd(x, y);
  return [].concat(...arr).reduce((a, b) => _lcm(a, b));
};
```

```js
lcm(12, 7); // 84
lcm([1, 3, 4], 5); // 60
```
